# Advanced PM:
#  Includes: Records of all messages just incase they are some what offensive ;)
#  Acts like an e-mail app with an inbox and a sentbox
#  No need to find the players userid because a popup will apear after you say the command giving you the names
#  HudHints notify you when you get a message.
#  
#  Coded By: TaCo
#  Enjoy.
import es, popuplib, os.path, cPickle, playerlib, usermsg

info = es.AddonInfo()
info.name = 'Advanced PM'
info.version = '1.0'
info.url = 'http:forums.mattie.info/cs/forums/'
info.basename = 'advancedpm'
info.author = 'TaCo'

Players = {}

def load():
	if not es.exists('saycommand','!pm'):
		es.regsaycmd('!pm', 'advancedpm/pmSend', 'This command will send a person a PM')
	if not es.exists('saycommand','pmmenu'):
		es.regsaycmd('pmmenu', 'advancedpm/pmMenu', 'Configure and check your messages')
	if not es.exists('saycommand','pmhelp'):
		es.regsaycmd('pmhelp', 'advancedpm/pmHelp', 'Help with PMing')
	if not es.exists('saycommand','!reply'):
		es.regsaycmd('!reply', 'advancedpm/pmReply', 'Reply to the last person that sent you a message.')
	global Players 
	#This line here saves the file path of our addon and then adds the name of our stored file at the end of it 
	str_path = es.getAddonPath('advancedpm') + '/messages.db' 
	#Check if that stored file exists in the path given 
	if os.path.isfile(str_path): 
		#If it does we now use cPickle to open it 
		file_users = open(str_path) 
		#Bring it into memory using our Players dic 
		Players = cPickle.load(file_users) 
		# It is always good habbit to close our file when we are done with it 
		file_users.close()
	helpMenu = popuplib.create('HelpMenu')
	helpMenu.addline('PM Help:')
	helpMenu.addline('-----------')
	helpMenu.addline('Q. How do I PM some one?')
	helpMenu.addline('A. Type !pm in chat then type your message.')
	helpMenu.addline('Example: !pm Hey wats up TaCo?')
	helpMenu.addline(' ')
	helpMenu.addline('Q. How do I check my messages?')
	helpMenu.addline('A. Type pmmenu in chat to bring up your inbox')
	helpMenu.addline(' ')
	helpMenu.addline('Q. What if I dont want to say pmmenu to check my messages?')
	helpMenu.addline('A. Type pmmenu and go to settings and change the way you ')
	helpMenu.addline('want you messages to be displayed.')
	helpMenu.addline(' ')
	helpMenu.addline('-----------')
	helpMenu.addline('->9. Next')
	helpMenu.addline('0. Close')
	creditMenu = popuplib.create('CreditMenu')
	creditMenu.addline('Credits:')
	creditMenu.addline('-----------')
	creditMenu.addline('Advanced Private Messaging made by:')
	creditMenu.addline('{KDS}TaCo')
	creditMenu.addline(' ')
	creditMenu.addline('Made with:')
	creditMenu.addline('EventScripts 2.0 Python.')
	creditMenu.addline('www.mattie.info/cs/ for more scripts!')
	creditMenu.addline(' ')
	creditMenu.addline('-----------')
	creditMenu.addline('0. Close')
	helpMenu.submenu(9, 'HelpMenu2')
	helpMenu2 = popuplib.create('HelpMenu2')
	helpMenu2.addline('PM Help:')
	helpMenu2.addline('----------')
	helpMenu2.addline('Q. What does !reply do that !pm doesn\'t?')
	helpMenu2.addline('A. It sends your message to the last person who messaged you')
	helpMenu2.addline('this means you don\'t have to go threw the menu.')
	helpMenu2.addline(' ')
	helpMenu2.addline('Commands:')
	helpMenu2.addline('!pm <message>')
	helpMenu2.addline('!reply <message>')
	helpMenu2.addline('pmmenu (Inbox, Sentbox, Settings, Help, Credits)')
	helpMenu2.addline('pmhelp (This menu)')
	helpMenu2.addline('-----------')
	helpMenu2.addline('->8. Back')
	helpMenu2.addline('0. Close')
	helpMenu2.submenu(8, 'HelpMenu')
	settings = popuplib.easymenu('PMMenu', '_popup_choice', menuSelect)
	settings.settitle('Select an option:')
	settings.addoption(1, "Your Inbox")
	settings.addoption(2, "Your Sentbox")
	settings.addoption(3, "Settings")
	settings.addoption(4, "Help")
	settings.addoption(5, "Credits")

def player_activate(event_var):
	#Check to see if the connecting player already has a key in our dic 
	if Players.has_key(event_var['es_steamid']): 
		list = []
		list2 = []
		#If they do not lets make them one 
		#This line creates a dic with the steamid of our player within the dic 'Players' 
		Players[event_var['es_steamid']] = {} 
		#Now lets set some values to this new key we have created
		Players[event_var['es_steamid']]['_idle_string_'] = ""
		Players[event_var['es_steamid']]['sentbox'] = list2
		Players[event_var['es_steamid']]['inbox'] = list
		Players[event_var['es_steamid']]['reply_steamid'] = ""
		Players[event_var['es_steamid']]['settings'] = "Inbox"
		Players[event_var['es_steamid']]['settings2'] = "Delete"
		
def round_end(event_var): 
	global players 
	file_players = open(es.getAddonPath('advancedpm') + '/messages.db','w') 
	cPickle.dump(Players, file_players) 
	file_players.close()
		
def pmHelp():
	userid = es.getcmduserid()
	popuplib.send('HelpMenu', userid)
	
def pmSettings(userid):
	global Players
	steamid = es.getplayersteamid(userid)
	settings = popuplib.easymenu('player_settings', '_popup_choice', settingsSelected)
	settings.settitle('Settings:')
	settings.addoption(1, "Recieve messages by [%s]"%Players[steamid]['settings'])
	settings.addoption(2, "On button press inside Inbox & Sentbox [%s]"%Players[steamid]['settings2'])
	settings.addoption(3, "Erase all messages")
	settings.send(userid)
		
	
def pmSend():
	userid = es.getcmduserid()
	name = es.getplayername(userid)
	message = es.getargs()
	check = es.getargc()
	if check > 1:
		steamid = es.getplayersteamid(userid)
		es.dbgmsg(0,"MSG:\"%s\" sent from \"%s\" was sent!"%(message,name))
		Players[steamid]['_idle_string_'] = message
		sendPlayerMenu(userid)
	else:
		es.tell(userid, "Can't send an empty message!")

def pmMenu():
	userid = es.getcmduserid()
	popuplib.send('PMMenu',userid)
	
def pmSendMsg(target, text):
	es.usermsg('create', 'MyHudText' ,'HintText')
	es.usermsg('write', 'byte', 'MyHudText', 1)                     
	es.usermsg('write', 'string', 'MyHudText', text)
	es.usermsg('send', 'MyHudText', target, 0)
	es.usermsg('delete', 'MyHudText')
	
def pmReply():
	#with this command you can skip the popup to select a person to send to and send it to the last person who sent you a message.
	userid = es.getcmduserid()
	message = es.getargs()
	check = es.getargc()
	if check > 1:
		myPlayer = playerlib.getPlayer(userid)
		steamid = myPlayer.attributes['steamid']
		name = myPlayer.attributes['name']
		myPlayerList = playerlib.getPlayerList('#human')
		playerSend = ""
		for player in myPlayerList:
			playerSteamid = player.attributes['steamid']
			playerUserid = int(player)
			if playerSteamid == Players[steamid]['reply_steamid']:
				playerSend = playerSteamid
				target = playerUserid
		if not playerSend == "":
			myTarget = playerlib.getPlayer(target)
			callername = myTarget.attributes['name']
			getList = Players[playerSend]['inbox']
			getText = '\"' + message + '\" from: \"' + name + '\"'
			getList.append(getText)
			Players[playerSend]['inbox'] = getList
			getList = Players[steamid]['sentbox']
			getText = '\"' + message + '\" to: \"' + callername + '\"'
			getList.append(getText)
			Players[steamid]['sentbox'] = getList
			getText = '\"' + message + '\" from: \"' + name + '\"'
			if Players[playerSend]['settings'] == "Inbox":
				pmSendMsg(target, 'You have a new message!\nFrom: %s\nType pmmenu to view!'%name)
			if Players[playerSend]['settings'] == "Message":
				es.tell(target, "#multi", "#default[#lightgreenAdvancedPM#default] \'#green%s#default\' from: \'#green%s#default\'"%(message, name))
			if Players[playerSend]['settings'] == "HudHint":
				pmSendMsg(target, '%s\nFrom:%s'%(message, name))
		else:
			es.tell(userid,"No user found to reply too.")
	else:
		es.tell(userid, "Can't send an empty message!")
	
def menuSelect(userid, choice, popupid):
	global Players
	steamid = es.getplayersteamid(userid)
	if choice == 1:
		themenu = popuplib.easymenu('inbox_messages', '_popup_choice', dltMsg) 
		themenu.settitle('Messages:')
		inboxlist = Players[steamid]['inbox']
		if inboxlist == []:
			themenu.addoption(1, "No Messages")
		else:
			for i in range(len(inboxlist)): 
				message = inboxlist[i]	
				# the choice value will be the userid 	
				# the text shown in menu is the player name 	
				themenu.addoption(i, message) 
		# send the menu to caller 
		themenu.send(userid)
	if choice == 2:
		themenu = popuplib.easymenu('sentbox_messages', '_popup_choice', dltMsg) 
		themenu.settitle('Sent Messages:')
		sentboxlist = Players[steamid]['sentbox']
		if sentboxlist == []:
			themenu.addoption(1, "No Messages")
		else:
			for i in range(len(sentboxlist)): 
				message = sentboxlist[i]
				# the choice value will be the userid 	
				# the text shown in menu is the player name 	
				themenu.addoption(i, message) 
		# send the menu to caller 
		themenu.send(userid)
	if choice == 3:
		pmSettings(userid)
	if choice == 4:
		popuplib.send('HelpMenu', userid)
	if choice == 5:
		popuplib.send('CreditMenu', userid)
		
def dltMsg(userid, msgnumber, menuname):
	global Players
	steamid = es.getplayersteamid(userid)
	if not Players[steamid]['settings2'] == "Don\'t Delete":
		menuName2 = ""
		if menuname == 'sentbox_messages':
			menuName2 = "sentbox"
		else:
			menuName2 = "inbox"
		if not menuName2 == "":
			delList = Players[steamid][menuName2]
			if not delList == []:
				delMsg = delList[msgnumber]
				delList.remove(delMsg)
				Players[steamid][menuName2] = delList
	
def sendPlayerMenu(userid): 
    # Create the menu 
    themenu = popuplib.easymenu('player_list', '_popup_choice', playerSelected) 
    
    themenu.settitle('Select a player:') 
    
    playerlist = playerlib.getPlayerList('#all') 
    
    for player in playerlist: 
        t_userid = int(player) 
        t_name = player.get('name') 
        # the choice value will be the userid 
        # the text shown in menu is the player name 
        themenu.addoption(t_userid, t_name) 
    
    # send the menu to caller 
    themenu.send(userid)
	
def settingsSelected(caller, numpressed, menuname):
	global Players
	steamid = es.getplayersteamid(caller)
	setting = Players[steamid]['settings']
	setting2 = Players[steamid]['settings2']
	if numpressed == 1:
		if setting == "Inbox":
			Players[steamid]['settings'] = "Message"
			pmSettings(caller)
		if setting == "Message":
			Players[steamid]['settings'] = "HudHint"
			pmSettings(caller)
		if setting == "HudHint":
			Players[steamid]['settings'] = "Inbox"
			pmSettings(caller)
	if numpressed == 2:
		if setting2 == "Delete":
			Players[steamid]['settings2'] = "Don\'t Delete"
			pmSettings(caller)
		if setting2 == "Don\'t Delete":
			Players[steamid]['settings2'] = "Delete"
			pmSettings(caller)
	if numpressed == 3:
		Players[steamid]['inbox'] = []
		Players[steamid]['sentbox'] = []
		es.tell(caller, "#green", "Your messages have been deleted!")

def playerSelected(caller, target, menuname):
	global Players
	#Lets get all of our info
	player = playerlib.getPlayer(target)
	name = es.getplayername(target)
	callername = es.getplayername(caller)
	steamid1 = es.getplayersteamid(target)
	steamid2 = es.getplayersteamid(caller)
	#Now lets send that message
	text = Players[steamid2]['_idle_string_']
	getList = Players[steamid1]['inbox']
	getText = '\"' + text + '\" from: \"' + callername + '\"'
	getList.append(getText)
	Players[steamid1]['inbox'] = getList
	#Now lets put the message in your inbox
	getList = Players[steamid2]['sentbox']
	getText = '\"' + text + '\" to: \"' + name + '\"'
	getList.append(getText)
	Players[steamid2]['sentbox'] = getList
	#This is for pmReply()
	Players[steamid1]['reply_steamid'] = steamid2
	#Tell our user that he has a message
	getText = '\"' + text + '\" from: \"' + callername + '\"'
	if Players[steamid1]['settings'] == "Inbox":
		pmSendMsg(target, 'You have a new message!\nFrom: %s\nType pmmenu to view!'%name)
	if Players[steamid1]['settings'] == "Message":
		es.tell(target, "#multi", "#default[#lightgreenAdvancedPM#default] \'#green%s#default\' from: \'#green%s#default\'"%(text, callername))
	if Players[steamid1]['settings'] == "HudHint":
		pmSendMsg(target, '%s\nFrom:%s'%(text, name))	

def unload(): 
	global players 
	file_players = open(es.getAddonPath('advancedpm') + '/messages.db','w') 
	cPickle.dump(Players, file_players) 
	file_players.close()
	popuplib.delete('HelpMenu')
	popuplib.delete('HelpMenu2')
	popuplib.delete('PMMenu')